/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/
// @import '../../style/utils';

/* Hide the browser's default radio button */
@import "../../style/utils";

:host {
  cursor: pointer;
  display: inline-block;
  font-size: 24px;
  height: 24px;
  padding-left: $space-md;
  position: relative;
  transform-origin: 50% 50%;
  user-select: none;
  vertical-align: middle;
  width: 24px;

  /* On mouse-over, add a grey background color */
  &:hover input ~ .checkmark {
    background-color: var(--nv-theme-alt-2);
  }

  .checkmark-container {
    height: 24px;
    left: 0;
    position: absolute;
    top: 0;
    width: 24px;
  }

  input {
    cursor: pointer;
    display: none;
    opacity: 0;
    position: absolute;

    /* When the radio button is checked, add a blue background */
    /* stylelint-disable-next-line */
    &:checked ~ .checkmark-container .checkmark {
      animation: activeRadio $transition-entrance $transition-speed-input;
      background-color: var(--nv-theme-primary);
    }

    /* Show the indicator (dot/circle) when checked */
    /* stylelint-disable-next-line */
    &:checked ~ .checkmark-container .checkmark::after {
      animation: activeRadioAfter $transition-entrance $transition-speed-input;
      display: block;
    }

    /* Add color for before */
    /* stylelint-disable-next-line */
    &:checked ~ .checkmark-container .checkmark::before {
      @extend .transition-entrance;
      background-color: var(--nv-theme-primary);
      height: 0;
      transition: cubic-bezier(0.76, 0, 0.16, 1.01) 500ms;
      transition-delay: 0s, 100ms;
      transition-property: background, height;
    }
  }

  /* Create a custom radio button */
  .checkmark {
    background-color: var(--nv-theme-alt-2);
    border-radius: 50%;
    height: 24px;
    left: 50%;
    overflow: hidden;
    position: absolute;
    top: 50%;
    transform: translate(-50%, -50%);
    transform-origin: 50% 50%;
    transition: cubic-bezier(0.76, 0, 0.16, 1.01) 500ms;
    width: 24px;

    /* Style the indicator (dot/circle) */

    &::after {
      background-color: $white;
      border-radius: 50%;
      height: 10px;
      left: 50%;
      top: 50%;
      transform: translate(-50%, -50%);
      transform-origin: 50% 50%;
      width: 10px;
      z-index: 1;
    }

    &::before {
      background: var(--nv-theme-alt-2);
      bottom: 0;
      content: '';
      display: block;
      height: 100%;
      position: absolute;
      transform: rotate(-42deg);
      width: 100%;
      z-index: 2;
    }
  }

  /* Create the indicator (the dot/circle - hidden when not checked) */
  .checkmark::after {
    content: '';
    display: none;
    position: absolute;
  }
}

@keyframes activeRadio {
  0% {
    height: 24px;
    width: 24px;
  }

  50% {
    height: 30px;
    width: 30px;
  }

  100% {
    height: 24px;
    width: 24px;
  }
}

@keyframes activeRadioAfter {
  0% {
    height: 10px;
    width: 10px;
  }

  50% {
    height: 16px;
    width: 16px;
  }

  100% {
    height: 10px;
    width: 10px;
  }
}
